/***************************************************************************
 *   Copyright (C) 2005 - 2006 by Christian Muehlhaeuser, Last.fm Ltd.     *
 *   chris@last.fm                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA  02111-1307, USA.          *
 ***************************************************************************/

#include <QtCore>

#include "ui_tagdialog.h"

#include "song.h"

class TagDialog : public QDialog
{
    Q_OBJECT

    public:
        TagDialog( QWidget *parent );

        void setSong( Song *song );

    private:
        Ui::TagDialog ui;

        bool m_collapsed;
        Song *m_song;

    public slots:
        void toggleCollapse();

    private slots:
        void okPressed();

        void tagTypeChanged( int type );

        void tagsForArtistResult( const QStringList &result );
        void tagsForUserResult( const QStringList &result );
        void tagsForUserArtistResult( const QStringList &result );
        void tagsForUserTrackResult( const QStringList &result );
        void tagsForUserAlbumResult( const QStringList &result );

        void addTag( QListWidgetItem *item );
};

